function [M1, M2]=GenGameMatrix(n1,n2,gc1,gc2,rc1,rc2)
% M1 is the cost matrix of network 1
% M2 is the cost matrix of network 2
% n1 is the gateway number of network 1
% n2 is the gateway number of network 2
% gc1 is the gateway cost of network 1
% gc2 is the gateway cost of network 2
% rc1 is the route cost of network 1
% rc2 is the route cost of network 2
M1=zeros(n1*n2, n1*n2);
M2=zeros(n1*n2, n1*n2);
for i=1:n1*n2
    for j=1:n1*n2
        gi=mod(i,n2);
        if(~gi)
            gi=n2;
        end       
        gj=mod(j,n1);
        if(~gj)
            gj=n1;
        end
        M1(i,j)=gc1(gj)+rc1(i);
        M2(i,j)=gc2(gi)+rc2(j);
    end
end
