clear;clc;
file='result.dat';
fid = fopen(file,'r');
result = fscanf(fid, '%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f', [24,inf]);
fclose(fid);
cost=result([3 4 9 10 15 15],:);
div=result([5 6 11 12 17 18],:);
stab=result([7 8 13 14 19 20],:);
label = [ 'AS 12182';
          'AS 4685 ';
          'AS 12182';
          'AS 4685 ';
          'AS 12182';
          'AS 4685 '];
liney=-1:5:1000;
linex1=2.5*ones(size(liney));
linex2=4.5*ones(size(liney));
scrsz = get(0,'ScreenSize');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure('Position',[1 scrsz(4)/2 scrsz(3)/2 0.2*scrsz(3)]);
boxplot(cost');
% because each bin is .5 data units wide.
set(gca,'XLim',[.5 6.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:6])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label)
ylabel('routing cost');

hold on
plot(linex1,liney,':',linex2,liney,':');
plot(1:6,median(cost,2),'*');
hold off
y=22;
set(gca,'YLim',[-0.5 y]);
text(1.3, 24/25*y, 'E2E-TE');
text(3.3, 24/25*y, 'LISP');
text(5.3, 24/25*y, 'MP-BGP');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%figure(2)
figure('Position',[1 scrsz(4)/2 scrsz(3)/2 0.2*scrsz(3)]);
boxplot(div');
set(gca,'XLim',[.5 6.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:6])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label)
ylabel('path diversity of the routing solution');
hold on
plot(linex1,liney,':',linex2,liney,':');
plot(1:6,median(div,2),'*');
hold off
y=800;
set(gca,'YLim',[-0.5 y]);
text(1.3, 24/25*y, 'E2E-TE');
text(3.3, 24/25*y, 'LISP');
text(5.3, 24/25*y, 'MP-BGP');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure('Position',[1 scrsz(4)/2 scrsz(3)/2 0.2*scrsz(3)]);
%figure(3)
boxplot(stab');
set(gca,'XLim',[.5 6.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:6])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label);
ylabel('path stability of the routing solution');
hold on
plot(linex1,liney,':',linex2,liney,':');
plot(1:6,median(stab,2),'*');
hold off
y=1.1;
set(gca,'YLim',[-0.1 y]);
text(1.3, 24/25*y, 'E2E-TE');
text(3.3, 24/25*y, 'LISP');
text(5.3, 24/25*y, 'MP-BGP');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure('Position',[1 scrsz(4)/2 scrsz(3)/2 0.2*scrsz(3)]);
%figure(4)
subplot(1,2,1)
semilogy(result(1,:),'-d')
hold on
semilogy(result(2,:),'-s')
hold off
set(gca,'XLim',[0 130]);
legend('Nash equilibria', 'Pareto-superior Nash equilibria');

ylabel('Number of Nash equilibria');
subplot(1,2,2)
boxplot(result([1,2],:)');
set(gca,'XLim',[.5 2.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:2])  % This automatically sets 
                         % the XTickMode to manual.
hold on
plot(1:2,median(result([1,2],:),2),'*');
hold off
set(gca,'XTickLabel',label([1,2],:));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure('Position',[1 scrsz(4)/2 scrsz(3)/2 0.2*scrsz(3)]);
subplot(1,2,1)
plot(result(22,:),'-d')
hold on
plot(result(24,:),'-*r')
hold off
set(gca,'XLim',[0 130]);
set(gca,'YLim',[0.05 0.5]);
legend('AS 12182', 'AS 4685');
ylabel('Percentage of used locators');
subplot(1,2,2)
boxplot(result([22,24],:)')
set(gca,'YLim',[0.05 0.5]);
set(gca,'XLim',[.5 2.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:2])  % This automatically sets 
                         % the XTickMode to manual.
hold on
plot(1:2,median(result([22,24],:),2),'*');
hold off
set(gca,'XTickLabel',label([1,2],:));